package com.ac.refapp.hybris.service;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.inject.Inject;

import org.apache.log4j.Logger;
import org.switchyard.component.bean.Reference;
import org.switchyard.component.bean.Service;

import com.ac.refapp.hybris.api.domain.HybrisCustomer;
import com.ac.refapp.hybris.api.domain.HybrisOrder;
import com.ac.refapp.hybris.api.domain.HybrisOrderList;
import com.ac.refapp.hybris.model.Ticket;
import com.ac.refapp.hybris.route.QueueMessageRouter;

@Service(QueueMonitorService.class)
public class QueueMonitorServiceImpl implements QueueMonitorService {
	private static final Logger LOGGER = Logger
			.getLogger(QueueMonitorServiceImpl.class);

	@Inject
	@Reference
	private QueueMessageRouter queueMessageRouter;

	@Override
	public void greet(HybrisOrderList hybrisOrderList) {
		hybrisOrderList = getDemoData();

		LOGGER.info("this message from QueueMonitorServiceImpl"+ hybrisOrderList.getOrderfrom());
		Ticket ticket = new Ticket();
		ticket.setId("TCKT-" + System.currentTimeMillis());
		ticket.setHybrisOrderList(hybrisOrderList);
		// JbpmService jbpmService = EjbLocator.getJbpmService();
		// if(!jbpmService.checkHybrisOrder(hybrisOrder)){
		queueMessageRouter.orderRouter(ticket);
		// }
	}

	private HybrisOrderList getDemoData() {
		HybrisOrderList hybrisOrderList = new HybrisOrderList();
		hybrisOrderList.setOrderfrom("taobao");
		SimpleDateFormat simpleFormate = new SimpleDateFormat( "yyyy-MM-dd" );
		hybrisOrderList.setCreateTime(simpleFormate.format(new Date()));

		List<HybrisOrder> hybrisOrders = new ArrayList<HybrisOrder>();
		for (int i = 0; i < 3; i++) {
			HybrisOrder hybrisOrder = new HybrisOrder();
			hybrisOrder.setDate(new Date());
			hybrisOrder.setOrdercode("ordercode" + i);

			HybrisCustomer hybrisCustomer = new HybrisCustomer();
			hybrisCustomer.setName("name" + i);
			hybrisOrder.setHybrisCustomer(hybrisCustomer);

			hybrisOrders.add(hybrisOrder);
		}
		hybrisOrderList.setHybrisOrders(hybrisOrders);

		return hybrisOrderList;

	}
}
